/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is the reusable ccl java library
 * (http://www.kclee.com/clemens/java/ccl/).
 *
 * The Initial Developer of the Original Code is
 * Chr. Clemens Lee.
 * Portions created by Chr. Clemens Lee are Copyright (C) 2002
 * Chr. Clemens Lee. All Rights Reserved.
 *
 * Contributor(s): Chr. Clemens Lee <clemens@kclee.com>
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */

package ccl.util.test;

import ccl.util.Singleton;
import ccl.util.Test;

/**
 * Minimal test of ccl.util.Singleton.
 * 
 * @version $Id: SingletonTest.java,v 1.5 2003/05/01 16:44:49 clemens Exp clemens $
 * @author <a href="http://www.kclee.com/clemens/">
 *         Chr. Clemens Lee</a>
 *         &lt;<a href="mailto:clemens@kclee.com">
 *         clemens@kclee.com
 *         </a>>
 */
public class SingletonTest extends Test 
{
    public SingletonTest() 
    {
        super();
    }
    
    public SingletonTest(Test pTest_) 
    {
        super(pTest_);
    }
    
    /**
     * Insert your test code into the _doIt() method and
     * test bugs with 'bugIf(boolean expression);' or
     * 'bugIf(boolean expression, "comment about what went wrong");'.
     * Then just run the main routine.
     */
    protected void _doIt() 
    {
        Object oInstance = Singleton.getInstance();
        bugIf( oInstance == null );
        Object oAnotherInstance = Singleton.getInstance();
        bugIf( oInstance != oAnotherInstance );
    }

    public static void main(String[] asArg_) 
    {
        Test pTest = (Test) (new SingletonTest());
        Test.printResult(pTest);
        System.exit(0);
    }
}
